#pragma once

/////////////
// GLOBALS //
/////////////
const bool FULL_SCREEN = false;
const bool VSYNC_ENABLED = true;
const float SCREEN_DEPTH = 1500.0f;
const float SCREEN_NEAR = 0.1f;


class InputClass;
class D3DClass;
class ShaderManagerClass;
class TextureManagerClass;
class TimerClass;
class FpsClass;
class ZoneClass;


class ApplicationClass
{
public:
	ApplicationClass();
	ApplicationClass(const ApplicationClass&);
	~ApplicationClass();

	bool Initialize(HINSTANCE, HWND, int, int);
	void Shutdown();
	bool Frame();

private:
	InputClass* m_Input = nullptr;
	D3DClass* m_Direct3D = nullptr;
	ShaderManagerClass* m_ShaderManager = nullptr;
	TextureManagerClass* m_TextureManager = nullptr;
	TimerClass* m_Timer = nullptr;
	FpsClass* m_Fps = nullptr;
	ZoneClass* m_Zone = nullptr;
};