#include "stdafx.h"
#include "ApplicationClass.h"
#include "systemclass.h"


SystemClass::SystemClass()
{
}


SystemClass::SystemClass(const SystemClass& other)
{
}


SystemClass::~SystemClass()
{
}


bool SystemClass::Initialize()
{
	//  â ,    ʱȭ
	int screenWidth = 0;
	int screenHeight = 0;

	//   ʱȭ
	InitializeWindows(screenWidth, screenHeight);

	//  α׷ ü մϴ.
	m_Application = new ApplicationClass;
	if(!m_Application)
	{
		return false;
	}

	//  α׷ ü ʱȭ մϴ.
	if(!m_Application->Initialize(m_hinstance, m_hwnd, screenWidth, screenHeight))
	{
		MessageBox(m_hwnd, L"Could not initialize the application object.", L"Error", MB_OK);
		return false;
	}
	
	return true;
}


void SystemClass::Shutdown()
{
	//  α׷ ü մϴ.
	if(m_Application)
	{
		m_Application->Shutdown();
		delete m_Application;
		m_Application = 0;
	}

	// 츦 մϴ.
	ShutdownWindows();
}


void SystemClass::Run()
{
	// ޽ ü   ʱȭ
	MSG msg;
	ZeroMemory(&msg, sizeof(MSG));

	// ڷκ  ޽  ޽ ϴ
	while (true)
	{
		//  ޽ óմϴ
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			//  ޽   ޽  Żմϴ
			if (msg.message == WM_QUIT)
				break;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			//  ܿ Frame Լ óմϴ.
			if (!Frame())
				break;
		}
	}
}


bool SystemClass::Frame()
{
	//  α׷ ü   ó մϴ.
	return m_Application->Frame();
}


LRESULT CALLBACK SystemClass::MessageHandler(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	return DefWindowProc(hwnd, umsg, wparam, lparam);
}


void SystemClass::InitializeWindows(int& screenWidth, int& screenHeight)
{
	// ܺ ͸  ü մϴ
	ApplicationHandle = this;

	//  α׷ νϽ ɴϴ
	m_hinstance = GetModuleHandle(NULL);

	// α׷ ̸ մϴ
	m_applicationName = L"Dx11Terrain_20";

	// windows Ŭ Ʒ  մϴ.
	WNDCLASSEX wc;
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = m_hinstance;
	wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = m_applicationName;
	wc.cbSize = sizeof(WNDCLASSEX);

	// windows class մϴ
	RegisterClassEx(&wc);

	//  ȭ ػ󵵸 оɴϴ
	screenWidth = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);

	int posX = 0;
	int posY = 0;

	// FULL_SCREEN    ȭ մϴ.
	if (FULL_SCREEN)
	{
		// Ǯũ  ߴٸ  ȭ ػ󵵸 ũ ػ󵵷 ϰ  32bit մϴ.
		DEVMODE dmScreenSettings;
		memset(&dmScreenSettings, 0, sizeof(dmScreenSettings));
		dmScreenSettings.dmSize = sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth = (unsigned long)screenWidth;
		dmScreenSettings.dmPelsHeight = (unsigned long)screenHeight;
		dmScreenSettings.dmBitsPerPel = 32;
		dmScreenSettings.dmFields = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;

		// Ǯũ ÷  մϴ.
		ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN);
	}
	else
	{
		//    800 * 600 ũ⸦ մϴ.
		screenWidth = 800;
		screenHeight = 600;

		//  â ,     մϴ.
		posX = (GetSystemMetrics(SM_CXSCREEN) - screenWidth) / 2;
		posY = (GetSystemMetrics(SM_CYSCREEN) - screenHeight) / 2;
	}

	// 츦 ϰ ڵ մϴ.
	m_hwnd = CreateWindowEx(WS_EX_APPWINDOW, m_applicationName, m_applicationName,
							WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_POPUP,
							posX, posY, screenWidth, screenHeight, NULL, NULL, m_hinstance, NULL);

	// 츦 ȭ鿡 ǥϰ Ŀ մϴ
	ShowWindow(m_hwnd, SW_SHOW);
	SetForegroundWindow(m_hwnd);
	SetFocus(m_hwnd);

	// Hide the mouse cursor.
	ShowCursor(false);
}


void SystemClass::ShutdownWindows()
{
	// Show the mouse cursor.
	ShowCursor(true);
	
	// Ǯũ 忴ٸ ÷  ʱȭմϴ.
	if (FULL_SCREEN)
	{
		ChangeDisplaySettings(NULL, 0);
	}

	// â մϴ
	DestroyWindow(m_hwnd);
	m_hwnd = NULL;

	// α׷ νϽ մϴ
	UnregisterClass(m_applicationName, m_hinstance);
	m_hinstance = NULL;

	// ܺ  ʱȭմϴ
	ApplicationHandle = NULL;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT umessage, WPARAM wparam, LPARAM lparam)
{
	switch (umessage)
	{
		//  Ḧ Ȯմϴ
	case WM_DESTROY:
	{
		PostQuitMessage(0);
		return 0;
	}

	// 찡  Ȯմϴ
	case WM_CLOSE:
	{
		PostQuitMessage(0);
		return 0;
	}

	//    ޽ ý Ŭ ޽ ó ѱϴ.
	default:
	{
		return ApplicationHandle->MessageHandler(hwnd, umessage, wparam, lparam);
	}
	}
}