#include "stdafx.h"
#include "FontClass.h"
#include "shadermanagerclass.h"
#include "TextClass.h"


TextClass::TextClass()
{
}

TextClass::TextClass(const TextClass& other)
{
}

TextClass::~TextClass()
{
}


bool TextClass::Initialize(ID3D11Device* device, ID3D11DeviceContext* deviceContext, int screenWidth, int screenHeight, int maxLength, 
						   bool shadow, FontClass* Font, const char* text, int positionX, int positionY, float red, float green, float blue)
{
	// ȭ ʺ ̸ մϴ.
	m_screenWidth = screenWidth;
	m_screenHeight = screenHeight;

	//  ִ ̸ մϴ.
	m_maxLength = maxLength;

	//    ƴ մϴ.
	m_shadow = shadow;
	
	//  ʱȭմϴ
	return InitializeSentence(device, deviceContext, Font, text, positionX, positionY, red, green, blue);
}


void TextClass::Shutdown()
{
	// ۸ մϴ.
	if(m_vertexBuffer)
	{
		m_vertexBuffer->Release();
		m_vertexBuffer = 0;
	}

	if(m_indexBuffer)
	{
		m_indexBuffer->Release();
		m_indexBuffer = 0;
	}

	if(m_vertexBuffer2)
	{
		m_vertexBuffer2->Release();
		m_vertexBuffer2 = 0;
	}

	if(m_indexBuffer2)
	{
		m_indexBuffer2->Release();
		m_indexBuffer2 = 0;
	}
}


void TextClass::Render(ID3D11DeviceContext* deviceContext, ShaderManagerClass* ShaderManager, XMMATRIX worldMatrix, XMMATRIX viewMatrix, 
					   XMMATRIX orthoMatrix, ID3D11ShaderResourceView* fontTexture)
{
	//  ׸ϴ.
	RenderSentence(deviceContext, ShaderManager, worldMatrix, viewMatrix, orthoMatrix, fontTexture);
}


bool TextClass::InitializeSentence(ID3D11Device* device, ID3D11DeviceContext* deviceContext, FontClass* Font, const char* text, int positionX,
								   int positionY, float red, float green, float blue)
{
	// ؽ ε  մϴ.
	m_vertexCount = 6 * m_maxLength;
	m_indexCount = 6 * m_maxLength;

	//  迭 ϴ.
	VertexType* vertices = new VertexType[m_vertexCount];
	if (!vertices)
	{
		return false;
	}

	// ε 迭 ϴ.
	unsigned long* indices = new unsigned long[m_indexCount];
	if (!indices)
	{
		return false;
	}

	// ó  迭 0 ʱȭմϴ.
	memset(vertices, 0, (sizeof(VertexType) * m_vertexCount));

	// ε 迭 ʱȭմϴ.
	for (int i = 0; i<m_indexCount; i++)
	{
		indices[i] = i;
	}

	//     ü Ѵ.
	D3D11_BUFFER_DESC vertexBufferDesc;
	vertexBufferDesc.Usage = D3D11_USAGE_DYNAMIC;
	vertexBufferDesc.ByteWidth = sizeof(VertexType) * m_vertexCount;
	vertexBufferDesc.BindFlags = D3D11_BIND_VERTEX_BUFFER;
	vertexBufferDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
	vertexBufferDesc.MiscFlags = 0;
	vertexBufferDesc.StructureByteStride = 0;

	// subresource   Ϳ  ͸ մϴ.
	D3D11_SUBRESOURCE_DATA vertexData;
	vertexData.pSysMem = vertices;
	vertexData.SysMemPitch = 0;
	vertexData.SysMemSlicePitch = 0;

	//  ۸ .
	if (FAILED(device->CreateBuffer(&vertexBufferDesc, &vertexData, &m_vertexBuffer)))
	{
		return false;
	}

	//  ε  ü մϴ.
	D3D11_BUFFER_DESC indexBufferDesc;
	
	indexBufferDesc.Usage = D3D11_USAGE_DEFAULT;
	indexBufferDesc.ByteWidth = sizeof(unsigned long) * m_indexCount;
	indexBufferDesc.BindFlags = D3D11_BIND_INDEX_BUFFER;
	indexBufferDesc.CPUAccessFlags = 0;
	indexBufferDesc.MiscFlags = 0;
	indexBufferDesc.StructureByteStride = 0;

	//  ҽ  ε Ϳ  ͸ մϴ.
	D3D11_SUBRESOURCE_DATA indexData;
	indexData.pSysMem = indices;
	indexData.SysMemPitch = 0;
	indexData.SysMemSlicePitch = 0;

	// ε ۸ ϴ.
	if (FAILED(device->CreateBuffer(&indexBufferDesc, &indexData, &m_indexBuffer)))
	{
		return false;
	}
	
	// ׸ ó   °  ε ۸ ϴ.
	if(m_shadow)
	{
		if(FAILED(device->CreateBuffer(&vertexBufferDesc, &vertexData, &m_vertexBuffer2)))
		{
			return false;
		}

		if(FAILED(device->CreateBuffer(&indexBufferDesc, &indexData, &m_indexBuffer2)))
		{
			return false;
		}
	}

	//  ̻ ʿ   迭 մϴ.
	delete[] vertices;
	vertices = 0;

	//  ̻ ʿ  ε 迭 մϴ.
	delete[] indices;
	indices = 0;

	//  ؽƮ ͸  ۿ ߰մϴ.
	return UpdateSentence(deviceContext, Font, text, positionX, positionY, red, green, blue);
}


bool TextClass::UpdateSentence(ID3D11DeviceContext* deviceContext, FontClass* Font, const char* text, int positionX, int positionY, float red,
							   float green, float blue)
{
	//   մϴ.
	m_pixelColor = XMFLOAT4(red, green, blue, 1.0f);

	//    ÷ο츦 Ȯմϴ.
	if ((int)strlen(text) > m_maxLength)
	{
		return false;
	}

	//  迭 ϴ.
	VertexType* vertices = new VertexType[m_vertexCount];
	if (!vertices)
	{
		return false;
	}

	// ó  迭 0 ʱȭմϴ.
	memset(vertices, 0, (sizeof(VertexType) * m_vertexCount));

	// ׸⸦  ȭ鿡 X  Y ȼ ġ մϴ.
	float drawX = (float)(((m_screenWidth / 2) * -1) + positionX);
	float drawY = (float)((m_screenHeight / 2) - positionY);

	// Ʈ Ŭ Ͽ  ؽƮ  ׸ ġ  迭 ϴ.
	Font->BuildVertexArray((void*)vertices, text, drawX, drawY);

	// ؽ ۸   ֵ ޴ϴ.
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	if (FAILED(deviceContext->Map(m_vertexBuffer, 0, D3D11_MAP_WRITE_DISCARD, 0, &mappedResource)))
	{
		return false;
	}

	//   ͸ Ű ͸ ´.
	void* verticesPtr = (void*)mappedResource.pData;

	// ͸  ۿ մϴ.
	memcpy(verticesPtr, (void*)vertices, (sizeof(VertexType) * m_vertexCount));

	//    մϴ.
	deviceContext->Unmap(m_vertexBuffer, 0);
	
	// ׸ڰ ִ   °  ۿ ϰ   ȼ µ˴ϴ.
	if(m_shadow)
	{
		memset(vertices, 0, (sizeof(VertexType) * m_vertexCount));

		drawX = (float)((((m_screenWidth / 2) * -1) + positionX) + 2);
		drawY = (float)(((m_screenHeight / 2) - positionY) - 2);
		Font->BuildVertexArray((void*)vertices, text, drawX, drawY);

		if(FAILED(deviceContext->Map(m_vertexBuffer2, 0, D3D11_MAP_WRITE_DISCARD, 0, &mappedResource)))
		{
			return false;
		}

		//  ۿִ Ϳ  ͸ ɴϴ.
		verticesPtr = (void*)mappedResource.pData;
		memcpy(verticesPtr, (void*)vertices, (sizeof(VertexType) * m_vertexCount));
		deviceContext->Unmap(m_vertexBuffer2, 0);
	}

	//  ̻ ʿ   迭 մϴ.
	delete[] vertices;
	vertices = 0;

	return true;
}


void TextClass::RenderSentence(ID3D11DeviceContext* deviceContext, ShaderManagerClass* ShaderManager, XMMATRIX worldMatrix, XMMATRIX viewMatrix,
							   XMMATRIX orthoMatrix, ID3D11ShaderResourceView* fontTexture)
{
	//      մϴ.
	unsigned int stride = sizeof(VertexType);
	unsigned int offset = 0;
	
	// ׸ڰ ִ  ׸ ؽƮ  մϴ.
	if(m_shadow)
	{
		XMFLOAT4 shadowColor = XMFLOAT4(0.0f, 0.0f, 0.0f, 1.0f);
		deviceContext->IASetVertexBuffers(0, 1, &m_vertexBuffer2, &stride, &offset);
	    deviceContext->IASetIndexBuffer(m_indexBuffer2, DXGI_FORMAT_R32_UINT, 0);
	    deviceContext->IASetPrimitiveTopology(D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST);
		ShaderManager->RenderFontShader(deviceContext, m_indexCount, worldMatrix, viewMatrix, orthoMatrix, fontTexture, shadowColor);
	}

	//    ֵ Է  ε ۸ Ȱ մϴ.
	deviceContext->IASetVertexBuffers(0, 1, &m_vertexBuffer, &stride, &offset);
	deviceContext->IASetIndexBuffer(m_indexBuffer, DXGI_FORMAT_R32_UINT, 0);

	//   ۿ  Ǿ ϴ Ƽ  մϴ. 쿡 ﰢԴϴ.
	deviceContext->IASetPrimitiveTopology(D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST);
		
	ShaderManager->RenderFontShader(deviceContext, m_indexCount, worldMatrix, viewMatrix, orthoMatrix, fontTexture, m_pixelColor);
}