#include "stdafx.h"
#include "TextureClass.h"
#include <stdio.h>


TextureClass::TextureClass()
{
}


TextureClass::TextureClass(const TextureClass& other)
{
}


TextureClass::~TextureClass()
{
}


bool TextureClass::Initialize(ID3D11Device* device, ID3D11DeviceContext* deviceContext, const char* filename)
{
	int height = 0;
	int width = 0;
	
	// targa ̹ ͸ ޸𸮿εմϴ.
	if(!LoadTarga(filename, height, width))
	{
		return false;
	}

	// ؽó ü մϴ.
	D3D11_TEXTURE2D_DESC textureDesc;
	textureDesc.Height = height;
	textureDesc.Width = width;
	textureDesc.MipLevels = 0;
	textureDesc.ArraySize = 1;
	textureDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	textureDesc.SampleDesc.Count = 1;
	textureDesc.SampleDesc.Quality = 0;
	textureDesc.Usage = D3D11_USAGE_DEFAULT;
	textureDesc.BindFlags = D3D11_BIND_SHADER_RESOURCE | D3D11_BIND_RENDER_TARGET;
	textureDesc.CPUAccessFlags = 0;
	textureDesc.MiscFlags = D3D11_RESOURCE_MISC_GENERATE_MIPS;

	//  ؽó ϴ.
	if(FAILED(device->CreateTexture2D(&textureDesc, NULL, &m_texture)))
	{
		return false;
	}

	// targa ̹   ġ մϴ.
	unsigned int rowPitch = (width * 4) * sizeof(unsigned char);

	// targa ̹ ͸ ؽó մϴ.
	deviceContext->UpdateSubresource(m_texture, 0, NULL, m_targaData, rowPitch, 0);

	// ̴ ҽ  ü մϴ.
	D3D11_SHADER_RESOURCE_VIEW_DESC srvDesc;
	srvDesc.Format = textureDesc.Format;
	srvDesc.ViewDimension = D3D11_SRV_DIMENSION_TEXTURE2D;
	srvDesc.Texture2D.MostDetailedMip = 0;
	srvDesc.Texture2D.MipLevels = -1;

	// ؽó ̴ ҽ 並 ϴ.
	if(FAILED(device->CreateShaderResourceView(m_texture, &srvDesc, &m_textureView)))
	{
		return false;
	}

	// ؽó  Ӹ մϴ.
	deviceContext->GenerateMips(m_textureView);
	
	// ̹ Ͱ ؽóεǾǷ targa ̹ ͸ մϴ.
	delete [] m_targaData;
	m_targaData = 0;

	return true;
}


void TextureClass::Shutdown()
{
	// ؽó  ü մϴ.
	if(m_textureView)
	{
		m_textureView->Release();
		m_textureView = 0;
	}

	// ؽó մϴ.
	if(m_texture)
	{
		m_texture->Release();
		m_texture = 0;
	}

	// targa ͸ մϴ.
	if(m_targaData)
	{
		delete [] m_targaData;
		m_targaData = 0;
	}
}


ID3D11ShaderResourceView* TextureClass::GetTexture()
{
	return m_textureView;
}


bool TextureClass::LoadTarga(const char* filename, int& height, int& width)
{
	// ̳ʸ   ֵ targa  ϴ.
	FILE* filePtr = nullptr;
	if(fopen_s(&filePtr, filename, "rb") != 0)
	{
		return false;
	}

	//   нϴ.
	TargaHeader targaFileHeader;
	if(fread(&targaFileHeader, sizeof(TargaHeader), 1, filePtr) != 1)
	{
		return false;
	}

	//  ߿  ´.
	height = (int)targaFileHeader.height;
	width = (int)targaFileHeader.width;
	int bpp = (int)targaFileHeader.bpp;

	// װ 24 Ʈ ƴ 32 Ʈ ȮϽʽÿ.
	if(bpp != 32)
	{
		return false;
	}

	// 32 Ʈ ̹  ũ⸦ մϴ.
	int imageSize = width * height * 4;

	// targa ̹   ޸𸮸 Ҵմϴ.
	unsigned char* targaImage = new unsigned char[imageSize];
	if(!targaImage)
	{
		return false;
	}

	// targa ̹ ͸ нϴ.	
	if(fread(targaImage, 1, imageSize, filePtr) != imageSize)
	{
		return false;
	}

	//  ݽϴ.
	if(fclose(filePtr) != 0)
	{
		return false;
	}

	// targa  Ϳ  ޸𸮸 Ҵմϴ.
	m_targaData = new unsigned char[imageSize];
	if(!m_targaData)
	{
		return false;
	}
	
	// targa   迭 ε ʱȭմϴ.
	int index = 0;

	// targa ̹ Ϳ ε ʱȭմϴ.
	int k = (width * height * 4) - (width * 4);

	//  targa  Ųٷ ǾǷ ùٸ  targa ̹ ͸ targa  迭 մϴ.
	for(int j=0; j<height; j++)
	{
		for(int i=0; i<width; i++)
		{
			m_targaData[index + 0] = targaImage[k + 2];  // 
			m_targaData[index + 1] = targaImage[k + 1];  // 
			m_targaData[index + 2] = targaImage[k + 0];  // Ķ
			m_targaData[index + 3] = targaImage[k + 3];  // 

			// ε targa ͷ ŵϴ.
			k += 4;
			index += 4;
		}

		// targa ̹  ε      κп   ٽ մϴ.
		k -= (width * 8);
	}
	
	//  迭   targa ̹ ͸ մϴ.
	delete [] targaImage;
	targaImage = 0;

	return true;
}