#pragma once


class D3DClass;
class InputClass;
class ShaderManagerClass;
class TextureManagerClass;
class TimerClass;
class UserInterfaceClass;
class CameraClass;
class LightClass;
class PositionClass;
class SkyDomeClass;
class TerrainClass;


class ZoneClass
{
public:
	ZoneClass();
	ZoneClass(const ZoneClass&);
	~ZoneClass();

	bool Initialize(D3DClass*, HWND, int, int, float);
	void Shutdown();
	bool Frame(D3DClass*, InputClass*, ShaderManagerClass*, TextureManagerClass*, float, int);

private:
	void HandleMovementInput(InputClass*, float);
	bool Render(D3DClass*, ShaderManagerClass*, TextureManagerClass*);

private:
	UserInterfaceClass* m_UserInterface = nullptr;
	CameraClass* m_Camera = nullptr;
	LightClass* m_Light = nullptr;
	PositionClass* m_Position = nullptr;
	SkyDomeClass* m_SkyDome = nullptr;
	TerrainClass* m_Terrain = nullptr;
	bool m_displayUI = false;
	bool m_wireFrame = false;
};