#pragma once


class D3DClass;
class FontClass;
class TextClass;
class ShaderManagerClass;


class UserInterfaceClass
{
public:
	UserInterfaceClass();
	UserInterfaceClass(const UserInterfaceClass&);
	~UserInterfaceClass();

	bool Initialize(D3DClass*, int, int);
	void Shutdown();

	bool Frame(ID3D11DeviceContext*, int, XMFLOAT3, XMFLOAT3);
	void Render(D3DClass*, ShaderManagerClass*, XMMATRIX, XMMATRIX, XMMATRIX);

private:
	bool UpdateFpsString(ID3D11DeviceContext*, int);
	bool UpdatePositionStrings(ID3D11DeviceContext*, XMFLOAT3, XMFLOAT3);

private:
	FontClass* m_Font1 = nullptr;
	TextClass* m_FpsString = nullptr;
	int m_previousFps = 0;
	TextClass *m_PositionStrings = nullptr;
	TextClass *m_VideoStrings = nullptr;
	XMFLOAT3 m_previousPosition = { 0.0f, 0.0f, 0.0f };
	XMFLOAT3 m_previousRotation = { 0.0f, 0.0f, 0.0f };
};